unit ZCoreEngine;

interface

{$I ZCore.inc}

uses
  Classes, {$IFDEF MSEgui}mclasses,{$ENDIF}
  Variants, Math, Types, SysConst, DateUtils, StrUtils,
  {$IFDEF WITH_LCONVENCODING}
  LConvEncoding,
  {$ENDIF}
{$IFDEF FPC}
  {$IFDEF UNIX}
    dynlibs,
  {$endif}
{$ENDIF}
  {$IFDEF WITH_WIDESTRUTILS}
  WideStrUtils,
  {$ENDIF}
  {$IFNDEF HAVE_TBYTES}
  Types,
  {$ENDIF}
  {$IF defined(MSWINDOWS) and not defined(WITH_UNICODEFROMLOCALECHARS)}
  Windows,
  {$IFEND}
  SysUtils, ZStrings;

{$i ZCompatibility.inc}
{$i ZFastCode.inc}
{$i ZSysUtils.inc}
{$i ZEncoding.inc}
{$i ZMessages.inc}

implementation

{$i ZCompatibility_imp.inc}
{$i ZEncoding_imp.inc}
{$i ZFastCode_imp.inc}
{$i ZMessages_imp.inc}
{$i ZSysUtils_imp.inc}

initialization

FillTwoDigitLoopLW;

{$If defined(Use_FastCodeFillChar) or defined(PatchSystemMove) or defined(USE_FAST_STRLEN) or defined(USE_FAST_CHARPOS)}
  GetCPUInfo;
  GetFastCodeTarget;
{$IFEND}

{$IFDEF Use_FastCodeFillChar}
  if isSSE3 in CPU.InstructionSupport then
    FillChar := FillChar_DKC_SSE2_10_b {Processor Supports SSE3}
  else
    if isSSE2 in CPU.InstructionSupport then
      FillChar := FillChar_DKC_SSE2_10_b {Processor Supports SSE2}
    else
      if isSSE in CPU.InstructionSupport then
        FillChar := FillChar_JOH_SSE_1_d {Processor Supports SSE}
      else
        if isMMX in CPU.InstructionSupport then
          FillChar := FillChar_JOH_MMX_4_b {Processor Supports MMX}
        else
          FillChar := FillChar_JOH_IA32_4_a; {Processor does not Support MMX or SSE}
{$ENDIF Use_FastCodeFillChar}

{$IFDEF PatchSystemMove} //set in Zeos.inc
  if isSSE3 in CPU.InstructionSupport then
    Move := Move_JOH_SSE3_10 {Processor Supports SSE3}
  else
    if isSSE2 in CPU.InstructionSupport then
      Move := Move_JOH_SSE2_10 {Processor Supports SSE2}
    else
      if isSSE in CPU.InstructionSupport then
        Move := Move_JOH_SSE_10 {Processor Supports SSE}
      else
        if isMMX in CPU.InstructionSupport then
          Move := Move_JOH_MMX_10 {Processor Supports MMX}
        else
          Move := Move_JOH_IA32_10; {Processor does not Support MMX or SSE}
  CacheLimit := CPU.L2CacheSize * -512; {Used within SSE Based Moves}
  PatchMove; {Patch Delphi's System.Move}
{$ENDIF PatchSystemMove} //set in Zeos.inc

{$IFDEF USE_FAST_STRLEN}
  if isSSE3 in CPU.InstructionSupport then
    StrLen := StrLen_JOH_SSE2_2_a {Processor Supports SSE3}
  else
    if isSSE2 in CPU.InstructionSupport then
      StrLen := StrLen_JOH_SSE2_2_a {Processor Supports SSE2}
    else
      StrLen := StrLen_JOH_IA32_7_d; {Processor does not Support SSE3 or SSE2}
{$ELSE}
  {$IFDEF WITH_STRLEN_DEPRECATED}
    StrLen := AnsiStrings.StrLen;
  {$ELSE}
    StrLen := {$IFDEF FPC}System.{$ELSE}SysUtils.{$ENDIF}StrLen;
  {$ENDIF WITH_STRLEN_DEPRECATED}
{$ENDIF USE_FAST_STRLEN}

{$IFDEF USE_FAST_CHARPOS}
if isSSE2 in CPU.InstructionSupport then
  CharPos := CharPos_JOH_SSE2_1_c {Processor Supports SSE2}
else
  CharPos := CharPos_Sha_Pas_2_b;
{$ENDIF}

//--------------------------

  SetDefaultSystemCodePage;

  case ConSettingsDummy.CPType of
    cCP_UTF16, cGET_ACP: ConSettingsDummy.CTRL_CP := ZDefaultSystemCodePage;
    cCP_UTF8: ConSettingsDummy.CTRL_CP := zCP_UTF8;
  end;
  SetConvertFunctions(@ConSettingsDummy);
  
//----------------------------------
loadmessages;

//-------------------------------

HexFiller;  //build up lookup table
end.
